<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AffiliateSiteFilter StructType
 * @subpackage Structs
 */
class AffiliateSiteFilter extends AbstractStructBase
{
    /**
     * The ID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var int
     */
    public $ID;
    /**
     * The query
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var string
     */
    public $query;
    /**
     * The affiliateSiteCategoryID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var int
     */
    public $affiliateSiteCategoryID;
    /**
     * The affiliateSiteTypeID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var int
     */
    public $affiliateSiteTypeID;
    /**
     * The affiliateSiteStatus
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var string
     */
    public $affiliateSiteStatus;
    /**
     * The limit
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var int
     */
    public $limit;
    /**
     * The offset
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var int
     */
    public $offset;
    /**
     * The sort
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var string
     */
    public $sort;
    /**
     * The sortDirection
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var string
     */
    public $sortDirection;
    /**
     * The excludeInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $excludeInfo;
    /**
     * Constructor method for AffiliateSiteFilter
     * @uses AffiliateSiteFilter::setID()
     * @uses AffiliateSiteFilter::setQuery()
     * @uses AffiliateSiteFilter::setAffiliateSiteCategoryID()
     * @uses AffiliateSiteFilter::setAffiliateSiteTypeID()
     * @uses AffiliateSiteFilter::setAffiliateSiteStatus()
     * @uses AffiliateSiteFilter::setLimit()
     * @uses AffiliateSiteFilter::setOffset()
     * @uses AffiliateSiteFilter::setSort()
     * @uses AffiliateSiteFilter::setSortDirection()
     * @uses AffiliateSiteFilter::setExcludeInfo()
     * @param int $iD
     * @param string $query
     * @param int $affiliateSiteCategoryID
     * @param int $affiliateSiteTypeID
     * @param string $affiliateSiteStatus
     * @param int $limit
     * @param int $offset
     * @param string $sort
     * @param string $sortDirection
     * @param bool $excludeInfo
     */
    public function __construct($iD = null, $query = null, $affiliateSiteCategoryID = null, $affiliateSiteTypeID = null, $affiliateSiteStatus = null, $limit = null, $offset = null, $sort = null, $sortDirection = null, $excludeInfo = null)
    {
        $this
            ->setID($iD)
            ->setQuery($query)
            ->setAffiliateSiteCategoryID($affiliateSiteCategoryID)
            ->setAffiliateSiteTypeID($affiliateSiteTypeID)
            ->setAffiliateSiteStatus($affiliateSiteStatus)
            ->setLimit($limit)
            ->setOffset($offset)
            ->setSort($sort)
            ->setSortDirection($sortDirection)
            ->setExcludeInfo($excludeInfo);
    }
    /**
     * Get ID value
     * @return int|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param int $iD
     * @return \StructType\AffiliateSiteFilter
     */
    public function setID($iD = null)
    {
        // validation for constraint: int
        if (!is_null($iD) && !is_numeric($iD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get query value
     * @return string|null
     */
    public function getQuery()
    {
        return $this->query;
    }
    /**
     * Set query value
     * @param string $query
     * @return \StructType\AffiliateSiteFilter
     */
    public function setQuery($query = null)
    {
        // validation for constraint: string
        if (!is_null($query) && !is_string($query)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($query)), __LINE__);
        }
        $this->query = $query;
        return $this;
    }
    /**
     * Get affiliateSiteCategoryID value
     * @return int|null
     */
    public function getAffiliateSiteCategoryID()
    {
        return $this->affiliateSiteCategoryID;
    }
    /**
     * Set affiliateSiteCategoryID value
     * @param int $affiliateSiteCategoryID
     * @return \StructType\AffiliateSiteFilter
     */
    public function setAffiliateSiteCategoryID($affiliateSiteCategoryID = null)
    {
        // validation for constraint: int
        if (!is_null($affiliateSiteCategoryID) && !is_numeric($affiliateSiteCategoryID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($affiliateSiteCategoryID)), __LINE__);
        }
        $this->affiliateSiteCategoryID = $affiliateSiteCategoryID;
        return $this;
    }
    /**
     * Get affiliateSiteTypeID value
     * @return int|null
     */
    public function getAffiliateSiteTypeID()
    {
        return $this->affiliateSiteTypeID;
    }
    /**
     * Set affiliateSiteTypeID value
     * @param int $affiliateSiteTypeID
     * @return \StructType\AffiliateSiteFilter
     */
    public function setAffiliateSiteTypeID($affiliateSiteTypeID = null)
    {
        // validation for constraint: int
        if (!is_null($affiliateSiteTypeID) && !is_numeric($affiliateSiteTypeID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($affiliateSiteTypeID)), __LINE__);
        }
        $this->affiliateSiteTypeID = $affiliateSiteTypeID;
        return $this;
    }
    /**
     * Get affiliateSiteStatus value
     * @return string|null
     */
    public function getAffiliateSiteStatus()
    {
        return $this->affiliateSiteStatus;
    }
    /**
     * Set affiliateSiteStatus value
     * @uses \EnumType\AffiliateSiteStatus::valueIsValid()
     * @uses \EnumType\AffiliateSiteStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $affiliateSiteStatus
     * @return \StructType\AffiliateSiteFilter
     */
    public function setAffiliateSiteStatus($affiliateSiteStatus = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AffiliateSiteStatus::valueIsValid($affiliateSiteStatus)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $affiliateSiteStatus, implode(', ', \EnumType\AffiliateSiteStatus::getValidValues())), __LINE__);
        }
        $this->affiliateSiteStatus = $affiliateSiteStatus;
        return $this;
    }
    /**
     * Get limit value
     * @return int|null
     */
    public function getLimit()
    {
        return $this->limit;
    }
    /**
     * Set limit value
     * @param int $limit
     * @return \StructType\AffiliateSiteFilter
     */
    public function setLimit($limit = null)
    {
        // validation for constraint: int
        if (!is_null($limit) && !is_numeric($limit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($limit)), __LINE__);
        }
        $this->limit = $limit;
        return $this;
    }
    /**
     * Get offset value
     * @return int|null
     */
    public function getOffset()
    {
        return $this->offset;
    }
    /**
     * Set offset value
     * @param int $offset
     * @return \StructType\AffiliateSiteFilter
     */
    public function setOffset($offset = null)
    {
        // validation for constraint: int
        if (!is_null($offset) && !is_numeric($offset)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($offset)), __LINE__);
        }
        $this->offset = $offset;
        return $this;
    }
    /**
     * Get sort value
     * @return string|null
     */
    public function getSort()
    {
        return $this->sort;
    }
    /**
     * Set sort value
     * @uses \EnumType\AffiliateSiteSort::valueIsValid()
     * @uses \EnumType\AffiliateSiteSort::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $sort
     * @return \StructType\AffiliateSiteFilter
     */
    public function setSort($sort = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\AffiliateSiteSort::valueIsValid($sort)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $sort, implode(', ', \EnumType\AffiliateSiteSort::getValidValues())), __LINE__);
        }
        $this->sort = $sort;
        return $this;
    }
    /**
     * Get sortDirection value
     * @return string|null
     */
    public function getSortDirection()
    {
        return $this->sortDirection;
    }
    /**
     * Set sortDirection value
     * @uses \EnumType\SortDirection::valueIsValid()
     * @uses \EnumType\SortDirection::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $sortDirection
     * @return \StructType\AffiliateSiteFilter
     */
    public function setSortDirection($sortDirection = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\SortDirection::valueIsValid($sortDirection)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $sortDirection, implode(', ', \EnumType\SortDirection::getValidValues())), __LINE__);
        }
        $this->sortDirection = $sortDirection;
        return $this;
    }
    /**
     * Get excludeInfo value
     * @return bool|null
     */
    public function getExcludeInfo()
    {
        return $this->excludeInfo;
    }
    /**
     * Set excludeInfo value
     * @param bool $excludeInfo
     * @return \StructType\AffiliateSiteFilter
     */
    public function setExcludeInfo($excludeInfo = null)
    {
        // validation for constraint: boolean
        if (!is_null($excludeInfo) && !is_bool($excludeInfo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($excludeInfo)), __LINE__);
        }
        $this->excludeInfo = $excludeInfo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AffiliateSiteFilter
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
